#include <tlang.h>
#include <stdio.h>
void register_funcs(runtime_t* rt)
{

}
#if defined(GEKKO)
#include <fat.h>
#include <stdio.h>
#include <stdlib.h>
#include <gccore.h>

void init_ogc(runtime_t* rt)
{
	#if defined(HW_RVL)
	__reg_wpad(rt);
	#endif
	VIDEO_Init();

    fatInitDefault();
	// Obtain the preferred video mode from the system
	// This will correspond to the settings in the Wii menu
	rmode = VIDEO_GetPreferredMode(NULL);

	// Allocate memory for the display in the uncached region
	xfb = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));

	// Initialise the console, required for printf
	console_init(xfb,20,20,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);

	// Set up the video registers with the chosen mode
	VIDEO_Configure(rmode);

	// Tell the video hardware where our display memory is
	VIDEO_SetNextFramebuffer(xfb);

	// Make the display visible
	VIDEO_SetBlack(FALSE);

	// Flush the video register changes to the hardware
	VIDEO_Flush();

	// Wait for Video setup to complete
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();


	// The console understands VT terminal escape codes
	// This positions the cursor on row 2, column 0
	// we can use variables for this with format codes too
	// e.g. printf ("\x1b[%d;%dH", row, column );
	printf("\x1b[2;0H");
}
#endif

int main(int argc,char** argv)
{
    runtime_t* rt = runtime_init();
    runtime_register_std(rt);
    runtime_register(rt,register_funcs);
    #if defined(GEKKO)
    init_ogc(rt);
    #endif
    if(argc < 2)
    {
        string_t* cmd=string_create();
        printf("TLang interactive shell.\nType \"exit\" to exit.\n");
        while(true)
        {
            string_clear(cmd);
            int c=-1;
            printf("> ");
            while((c = fgetc(stdin)) != '\n')
            {
                string_appendc(cmd,(char)c);
            }
            if(string_samep(cmd,"exit")) break;
            runtime_load(rt,cmd);
            tobject_t* o = runtime_exec(rt);
            tobject_freeifzero(o);
            node_free(rt->program);
            rt->program=NULL;
        }
        string_free(cmd);
    }
    else {
        string_t* cmd=string_create();
        
        FILE* f = fopen(argv[1],"r");
        if(f != NULL){
                string_read(cmd,f,fread);
                fclose(f);
        }
        
        runtime_load(rt,cmd);
        int i;
        for(i=2;i<argc;i++)
        {
            string_t* str = string_create();
            string_appendp(str,argv[i]);
            runtime_add_argument(rt,tobject_string(rt,str));
        }
        tobject_t* o = runtime_exec(rt);
        
        tobject_freeifzero(o);
        
        string_free(cmd);
    }

    runtime_free(rt);
    return 0;
}
